
var _userdata = require("userdata.js");
var userData = _userdata.userData;
const fs = require("@system.fs")


var systemCtrl = require("systemCtrl.js");
var resultsWifiList = undefined;
function parseWifiScanResults(output) {
    const lines = output.split('\n');
    const results = [];

    // 从第三行开始解析（跳过前两行标题）
    for (let i = 2; i < lines.length; i++) {
        const line = lines[i].trim();
        if (!line) continue; // 跳过空行

        // 按多个空格分割行
        const parts = line.split(/\s+/).filter(part => part !== '');

        if (parts.length >= 4) {
            const signalLevel = parseInt(parts[2]); // 信号强度在第3列
            let ssid = parts.slice(4).join(' '); // SSID 在第5列及之后（可能包含空格）
            const flags = parts[3]; // 加密标志在第4列
            const isEncrypted = !flags.includes("[ESS]") ||
                flags.includes("WPA") ||
                flags.includes("WEP") ||
                flags.includes("PSK");
            results.push({
                ssid: ssid || '', // 如果 SSID 为空，则设为空字符串
                signalLevel: signalLevel,
                isEncrypted: isEncrypted
            });
        }
    }

    return results;
}


var wlan_enalbed = userData.enableWLANSwitchFlag
// const generalSettingPage = proxy.indexObj.getPage("generalSetting");

var wifi_div = undefined;
var wifi_list_div = undefined;
// this.proxy = proxy;
// this.pageObj = proxy.indexObj.getPage("generalSetting");
// var that = this;



// proxy.on("onEnableWLANSwitch", function () {




function connect_wifi(ssid, psk) {
    systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 set_network 0 ssid \'\"" + ssid + "\"\'")
    systemCtrl.executeSystemCommand("usleep 10000") //10ms 用于缓冲
    systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 set_network 0 psk \'\"" + psk + "\"\'")
    systemCtrl.executeSystemCommand("usleep 10000") //10ms 用于缓冲
    systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 save_config")
    systemCtrl.executeSystemCommand("usleep 10000") //10ms 用于缓冲
    systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 reconfigure")
    //启动wpa_supplicant进程
    systemCtrl.executeSystemCommand("usleep 200000") //200ms 用于缓冲设置和执行
    systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 disable_network 0")
    systemCtrl.executeSystemCommand("usleep 10000") //10ms 用于缓冲
    systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 enable_network 0")
    systemCtrl.executeSystemCommand("usleep 500000") //500ms 用于缓冲联网状态
    //启动udhcpc
    systemCtrl.executeSystemCommand("udhcpc -b -i wlan0 -t 1 -A 1 -R -H test")
}
function diConnectWifi() {
    systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 disable_network 0")
    systemCtrl.executeSystemCommand("usleep 10000") // 10ms 用于缓冲
    systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 remove_network 0")
    systemCtrl.executeSystemCommand("usleep 10000") // 10ms 用于缓冲
    systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 save_config")
    systemCtrl.executeSystemCommand("usleep 10000") // 10ms 用于缓冲
    systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 reconfigure")
    systemCtrl.executeSystemCommand("usleep 200000") // 200ms 用于缓冲设置和执行
    systemCtrl.executeSystemCommand("killall -9 udhcpc") // 停止 udhcpc
}
function WifiNoActive() {

    console.log("=====WifiNoActive=====");

    userData.wlanSsid = null;
    userData.wlanSignalLevel = 0;
    userData.wlanPassword = null;

    that.pageObj.$setY("id_enableWLANListArea0", -800);
    that.pageObj.$setY("wifiListItem", 0);
    that.pageObj.$setY("id_wifiListItem_Text", -800);
    that.pageObj.$setY("id_wifiListItem_xLine", -800);


    systemCtrl.executeSystemCommand("ifconfig wlan0 down")
}
function refreshWifiList(wifi_list) {
    var enableWLANListItemSearchDiv = document.getElementById('id_enableWLANListItemSearchDiv')


    if (!enableWLANListItemSearchDiv)
        return

    if (!wifi_div) {
        wifi_div = document.createElement('div', {
            top: 0,
            left: 0,
            width: 420,
        }, enableWLANListItemSearchDiv)
    }
    console.log("=====refreshWifiListlog=====1");
    // if (wifi_list_div) {
    //     wifi_div.removeChild(wifi_list_div)
    // }

    wifi_list_div = document.createElement('div', {
        top: 0,
        left: 0,
        width: 420,
        "background-color": "#000000",
    }, wifi_div)
    console.log("=====refreshWifiListlog=====2");
    var top = 0;
    for (var i = 0; i < wifi_list.length; i++) {
        // if (wifi_list[i].ssid == userData.wlanSsid) {
        //     continue;
        // }
        var ssid = wifi_list[i].ssid
        var signalLevel = wifi_list[i].signalLevel
        var isEncrypted = wifi_list[i].isEncrypted

        if (ssid.length == 0)
            continue
        var process = require("@system.process");
        if (process.platform == "win32") {

            if (signalLevel > -50) {
                var src = './../re860a-v1.0/images/main/wifiSignalLevel3.png'
            } else if (signalLevel <= -50 && signalLevel > -70) {
                var src = './../re860a-v1.0/images/main/wifiSignalLevel2.png'
            } else {
                var src = './../re860a-v1.0/images/main/wifiSignalLevel1.png'
            }
        }
        else {

            if (signalLevel > -50) {
                var src = './../RE860A/images/main/wifiSignalLevel3.png'
            } else if (signalLevel <= -50 && signalLevel > -70) {
                var src = './../RE860A/images/main/wifiSignalLevel2.png'
            } else {
                var src = './../RE860A/images/main/wifiSignalLevel1.png'
            }
        }

        var chooseAreaDiv = document.createElement('div', {
            top: top,
            left: 20,
            width: 460,
            height: 66,
        }, wifi_list_div)


        document.createElement('text', {
            top: 14,
            left: 50,
            width: 420,
            height: 50,
            "text-align": "left",
            "font-size": 22,
            "color": "white",
            'text-overflow': "ellipsis",
            "background-color": "transparent",
            "text": ssid+"("+signalLevel+" dBm)",
            "signalValue": signalLevel,
            "events": {
                onclick: function (node, topNode, x, y) {
                    // node.attributes.text = "selected";
                    systemCtrl.executeSystemCommand("/mnt/app/quicknode/shell/eAplay.sh /mnt/app/voice_click.wav");
                    console.log("node.attributes.text = " + this.attributes.text);
                    console.log("click wlan_list_item"); //需要添加一个点击事件
                    proxy.emit("onGotoWlanEnterPasswordPage", this.attributes.text, this.attributes.signalValue);
                }
            }
        }, chooseAreaDiv)

        document.createElement('div', {
            top: 65,
            left: 8,
            width: 464,
            height: 1,
            opactity: 1,
            "background-color": "#999999",
        }, chooseAreaDiv)

        // if (isEncrypted) {
        //     document.createElement('img', {
        //         top: 20,
        //         left: 363,
        //         width: 21,
        //         height: 26,
        //         src: "./images/settings/connecteWlanLockedPng.png",
        //     }, chooseAreaDiv)
        // }

        document.createElement('img', {
            top: 14,
            left: 8,
            width: 38,
            height: 38,
            src: src,
        }, chooseAreaDiv)

            top += 70
    }

    wifi_list_div.setAttribute('height', top)
    wifi_div.setAttribute('height', top)
}


function enableWLANSwitch() {

    console.log("Is @@@@@@@@@@@@@@@@@@@@@@@@@@#3333333")
    // if (!userData.enableWLANSwitchFlag) {
    //     return;
    // }


    systemCtrl.executeSystemCommand("rm -fr /tmp/scan_result.txt")
    systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets scan")
    setTimeout(function () {

        systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets scan_results > /tmp/scan_result.txt")
        var content = fs.read("/tmp/scan_result.txt", "r")
        if (content) {
            resultsWifiList = parseWifiScanResults(content)
            // console.log(JSON.stringify(resultsWifiList))
            refreshWifiList(resultsWifiList)
        }
    }, 5000)

}




function getWifiInfo(ssid) {
    console.log("getWifiInfo called with SSID: " + ssid);
    if (!resultsWifiList) {
        console.log("resultsWifiList is not available.");
        return null; // 如果 resultsWifiList 为空，则返回 null
    }

    // 遍历 resultsWifiList 查找指定 SSID
    let foundWifi = null;
    for (let i = 0; i < resultsWifiList.length; i++) {
        if (resultsWifiList[i].ssid === ssid) {
            console.log("Found SSID: " + ssid);
            foundWifi = resultsWifiList[i];
            break;
        }
    }

    if (!foundWifi) {
        console.log("SSID not found: " + ssid);
        return {
            ssid: ssid,
            signalLevel: null, // 信号强度为空
            isEncrypted: null, // 加密状态为空
            isConnected: false // 未连接
        };
    }

    // 检查当前 WiFi 状态
    let isConnected = false;
    if (userData.wlanSsid === ssid && userData.enableWLANSwitchFlag === 1) {
        isConnected = true;
    } else {
        // 通过系统命令检查当前 WiFi 状态
        systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 status > /tmp/wifi_status.txt");
        const statusContent = fs.read("/tmp/wifi_status.txt", "r");
        if (statusContent) {
            const statusLines = statusContent.split('\n');
            for (let i = 0; i < statusLines.length; i++) {
                const line = statusLines[i].trim();
                if (line.startsWith("wpa_state=")) {
                    const state = line.split('=')[1];
                    if (state === "COMPLETED") {
                        isConnected = true;
                        break;
                    }
                }
            }
        }
    }

    return {
        ssid: ssid,
        signalLevel: foundWifi.signalLevel, // 信号强度
        isEncrypted: foundWifi.isEncrypted, // 是否加密
        isConnected: isConnected // 是否已连接
    };
}

module.exports = {
    enableWLANSwitch: enableWLANSwitch,
    connect_wifi: connect_wifi,
    getWifiInfo: getWifiInfo,


}