// const systemCtrl = require("systemCtrl.js");
const process = require("@system.process");
const rnapi = require('rnapi.js')
var _userdata = require("userdata.js");
var userData = _userdata.userData;
const fs = require("@system.fs")


var systemCtrl = require("systemCtrl.js");
const userdata = require("../logicJS/userdata");
var handleJumpPage = require("handleJumpPage.js");
// const system = rnapi.require('lib/system/build-lib/libsystem.so')

function parseWifiScanResults(output) {
    const lines = output.split('\n');
    const results = [];

    // 从第三行开始解析（跳过前两行标题）
    for (let i = 2; i < lines.length; i++) {
        const line = lines[i].trim();
        if (!line) continue; // 跳过空行

        // 按多个空格分割行
        const parts = line.split(/\s+/).filter(part => part !== '');

        if (parts.length >= 4) {
            const signalLevel = parseInt(parts[2]); // 信号强度在第3列
            let ssid = parts.slice(4).join(' '); // SSID 在第5列及之后（可能包含空格）
            const flags = parts[3]; // 加密标志在第4列
            const isEncrypted = !flags.includes("[ESS]") ||
                flags.includes("WPA") ||
                flags.includes("WEP") ||
                flags.includes("PSK");
            results.push({
                ssid: ssid || '', // 如果 SSID 为空，则设为空字符串
                signalLevel: signalLevel,
                isEncrypted: isEncrypted
            });
        }
    }

    return results;
}

function Wlan(proxy) {
    var wlan_enalbed = userData.enableWLANSwitchFlag
    const generalSettingPage = proxy.indexObj.getPage("generalSetting");

    var wifi_div = undefined;
    var wifi_list_div = undefined;
    this.proxy = proxy;
    this.pageObj = proxy.indexObj.getPage("generalSetting");
    var that = this;

    function refreshWifiList(wifi_list) {
        var enableWLANListItemSearchDiv = generalSettingPage.$getElementById('id_enableWLANListItemSearchDiv')

        if (!enableWLANListItemSearchDiv)
            return

        if (!wifi_div) {
            wifi_div = document.createElement('div', {
                top: 0,
                left: 0,
                width: 480,
            }, enableWLANListItemSearchDiv)
        }

        // if (wifi_list_div) {
        //     wifi_div.removeChild(wifi_list_div)
        // }

        wifi_list_div = document.createElement('div', {
            top: 0,
            left: 0,
            width: 480,
        }, wifi_div)
        var top = 0;
        for (var i = 0; i < wifi_list.length; i++) {
            if (wifi_list[i].ssid == userData.wlanSsid) {
                continue;
            }
            var ssid = wifi_list[i].ssid
            var signalLevel = wifi_list[i].signalLevel
            var isEncrypted = wifi_list[i].isEncrypted

            if (ssid.length == 0)
                continue

            if (signalLevel > -50) {
                var src = 'images/main/wifiSignalLevel3.png'
            } else if (signalLevel <= -50 && signalLevel > -70) {
                var src = 'images/main/wifiSignalLevel2.png'
            } else {
                var src = 'images/main/wifiSignalLevel1.png'
            }

            var chooseAreaDiv = document.createElement('div', {
                top: top,
                left: 20,
                width: 460,
                height: 66,
            }, wifi_list_div)


            document.createElement('text', {
                top: 14,
                left: 8,
                width: 480,
                height: 50,
                "text-align": "left",
                "font-size": 22,
                "color": "white",
                'text-overflow': "ellipsis",
                "background-color": "transparent",
                "text": ssid,
                "signalValue": signalLevel,
                "events": {
                    onclick: function (node, topNode, x, y) {
                        // node.attributes.text = "selected";
                        systemCtrl.executeSystemCommand("/mnt/app/quicknode/shell/eAplay.sh /mnt/app/voice_click.wav");
                        console.log("node.attributes.text = " + this.attributes.text);
                        console.log("click wlan_list_item"); //需要添加一个点击事件
                        proxy.emit("onGotoWlanEnterPasswordPage", this.attributes.text, this.attributes.signalValue);
                    }
                }
            }, chooseAreaDiv)

            document.createElement('div', {
                top: 65,
                left: 8,
                width: 464,
                height: 1,
                opactity: 1,
                "background-color": "#999999",
            }, chooseAreaDiv)

            if (isEncrypted) {
                document.createElement('img', {
                    top: 20,
                    left: 363,
                    width: 21,
                    height: 26,
                    src: "./images/settings/connecteWlanLockedPng.png",
                }, chooseAreaDiv)
            }

            document.createElement('img', {
                top: 14,
                left: 392,
                width: 38,
                height: 38,
                src: src,
            }, chooseAreaDiv)
            top += 70
        }

        wifi_list_div.setAttribute('height', top)
        wifi_div.setAttribute('height', top)
    }

    refreshWifiList([]);

    proxy.on("onEnableWLANSwitch", function () {
        console.debug("Is @@@@@@@@@@@@@@@@@@@@@@@@@@#3333333")


        if (!userData.enableWLANSwitchFlag) {
            return;
        }
        if (wifi_list_div) {
            wifi_div.removeChild(wifi_list_div)
        }

        // if (userData.wlanEnalbed)

        // if (wlan_enalbed) {
        // if (process.platform == "win32") {
        // systemCtrl.executeSystemCommand("wpa_cli scan")
        systemCtrl.executeSystemCommand("rm -fr /tmp/scan_result.txt")
        systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets scan")
        setTimeout(function () {
            // systemCtrl.executeSystemCommand("wpa_cli scan_results > /tmp/scan_result.txt")
            systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets scan_results > /tmp/scan_result.txt")
            var content = fs.read("/tmp/scan_result.txt", "r")
            if (content) {
                var results = parseWifiScanResults(content)
                console.debug(JSON.stringify(results))
                refreshWifiList(results)
            }
        }, 5000)
        // }

        // }
    })
    function connect_wifi(ssid, psk) {
        systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 set_network 0 ssid \'\"" + ssid + "\"\'")
        systemCtrl.executeSystemCommand("usleep 10000") //10ms 用于缓冲
        systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 set_network 0 psk \'\"" + psk + "\"\'")
        systemCtrl.executeSystemCommand("usleep 10000") //10ms 用于缓冲
        systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 save_config")
        systemCtrl.executeSystemCommand("usleep 10000") //10ms 用于缓冲
        systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 reconfigure")
        //启动wpa_supplicant进程
        systemCtrl.executeSystemCommand("usleep 200000") //200ms 用于缓冲设置和执行
        systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 disable_network 0")
        systemCtrl.executeSystemCommand("usleep 10000") //10ms 用于缓冲
        systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 enable_network 0")
        systemCtrl.executeSystemCommand("usleep 500000") //500ms 用于缓冲联网状态
        //启动udhcpc
        systemCtrl.executeSystemCommand("udhcpc -b -i wlan0 -t 1 -A 1 -R -H test")
    }
    function diConnectWifi() {
        systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 disable_network 0")
        systemCtrl.executeSystemCommand("usleep 10000") // 10ms 用于缓冲
        systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 remove_network 0")
        systemCtrl.executeSystemCommand("usleep 10000") // 10ms 用于缓冲
        systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 save_config")
        systemCtrl.executeSystemCommand("usleep 10000") // 10ms 用于缓冲
        systemCtrl.executeSystemCommand("wpa_cli -p /tmp/wpa_supplicant/sockets -i wlan0 reconfigure")
        systemCtrl.executeSystemCommand("usleep 200000") // 200ms 用于缓冲设置和执行
        systemCtrl.executeSystemCommand("killall -9 udhcpc") // 停止 udhcpc
    }
    function WifiNoActive() {

        console.debug("=====WifiNoActive=====");

        userData.wlanSsid = null;
        userData.wlanSignalLevel = 0;
        userData.wlanPassword = null;

        that.pageObj.$setY("id_enableWLANListArea0", -800);
        that.pageObj.$setY("wifiListItem", 0);
        that.pageObj.$setY("id_wifiListItem_Text", -800);
        that.pageObj.$setY("id_wifiListItem_xLine", -800);


        systemCtrl.executeSystemCommand("ifconfig wlan0 down")
    }



    proxy.on("onEnableWLANSwitchClick", function () {
        console.debug("onEnableWLANSwitchClick")
        if (userData.enableWLANSwitchFlag == 0) {


            userData.enableWLANSwitchFlag = 1;

            systemCtrl.executeSystemCommand("ifconfig wlan0 up")
            if (userData.wlanSsid != null) {
                console.debug("userData.wlanSsid :" + userData.wlanSsid + "userData.wlanPassword :" + userData.wlanPassword + "---> reload wifi");
                connect_wifi(userData.wlanSsid, userData.wlanPassword);
            }
            that.pageObj.refreshEnableWLANSwitchState(userData.enableWLANSwitchFlag);
            //判断文件是否有ssid ,如果有开启onGotoWlanEnterPasswordPage
        } else {
            userData.enableWLANSwitchFlag = 0;
            // diConnectWifi();
           WifiNoActive();

        }
        that.pageObj.refreshEnableWLANSwitchState(userData.enableWLANSwitchFlag);
    })





}

module.exports = {
    Wlan: Wlan
}